local myGuid;
local intFrame = CreateFrame("Frame",nil,UIParent);
intFrame:RegisterEvent("COMBAT_LOG_EVENT_UNFILTERED");
intFrame:RegisterEvent("PLAYER_ENTERING_WORLD");

function intEvent(self, event, ...)
	if (event == "COMBAT_LOG_EVENT_UNFILTERED") then
		local timestamp, event, hideCaster, sourceGUID, sourceName, sourceFlags, sourceRaidFlags, destGUID, destName, destFlags, destRaidFlags = select(1, ...);
		if (event == "SPELL_INTERRUPT") then
			local pSpellId, pSpellName, pSpellSchool, tSpellId,tSpellName, tSpellSchool = select(12, ...);
			if (sourceGUID == myGuid) then
				local start, duration, enabled = GetSpellCooldown(pSpellId);
				local tSpellLink = GetSpellLink(tSpellId);
				--SendChatMessage(pSpellName .. " [" .. tSpellName .. "] from <" .. destName .. "> (" .. duration .. "s cooldown).", "SAY", nil);
				SendChatMessage(pSpellName .. ": " .. tSpellLink .. " (" .. destName .. ")", "SAY", nil);
			end
		elseif (event == "SPELL_AURA_BROKEN_SPELL") then
			local spellID, spellName, spellSchool, extraSpellID, extraSpellName, extraSchool, auraType = select(12, ...);
			local spellLink = GetSpellLink(spellID);
			local eSpellLink = GetSpellLink(extraSpellID);
			if (auraType == "DEBUFF") then
				--SendChatMessage(sourceName .. " broke [" .. spellName .. "] with <" .. extraSpellName .. ">.", "SAY", nil);
				SendChatMessage(sourceName .. " broke " .. spellLink .. " with " ..  eSpellLink .. " (" .. getRaidIcon(destRaidFlags) .. destName .. getRaidIcon(destRaidFlags) .. ")", "SAY", nil);
			end
		elseif (event == "SPELL_AURA_BROKEN") then
				local spellID, spellName, spellSchool, auraType = select(12, ...);
				local spellLink = GetSpellLink(spellID);
				if (auraType == "DEBUFF" and isHostile(destFlags)) then
				SendChatMessage(sourceName .. " broke " .. spellLink .. " (" .. getRaidIcon(destRaidFlags) .. destName .. getRaidIcon(destRaidFlags) .. ")", "SAY", nil);
			end
			elseif (event == "SPELL_AURA_REMOVED") then
				local spellID, spellName, spellSchool, auraType = select(12, ...);
				local spellLink = GetSpellLink(spellID);
				if (auraType == "DEBUFF" and isCC(spellName) and isHostile(destFlags)) then
					SendChatMessage(formatName(sourceName) .. " " .. spellLink .. " wore off! (" .. getRaidIcon(destRaidFlags) .. destName .. getRaidIcon(destRaidFlags) .. ")", "SAY", nil);
				end
		--[[elseif (event == "SPELL_CREATE") then
			SendChatMessage(">>" .. sourceName .. " has created a " .. spellName .. "<<","RAID",nil);]]
		end
	elseif (event == "PLAYER_ENTERING_WORLD") then
		myGuid = UnitGUID("player");
		BNSetMatureLanguageFilter(false);
	end
end

function formatName(name)
	local strLen = string.len(name);
	local lastChar = string.sub(name, strLen);
	local newName;
	if (lastChar == "s") then
		newName = name .. "'";
	else
		newName = name .. "'s";
	end
	return newName;
end

function isHostile(flags)
	if (bit.band(flags, COMBATLOG_OBJECT_REACTION_HOSTILE) > 0) then 
		return true
	else
		return false
	end
end

function getRaidIcon(flags)
	if (bit.band(flags, COMBATLOG_OBJECT_RAIDTARGET1) > 0) then
		return "{star}";
	elseif (bit.band(flags, COMBATLOG_OBJECT_RAIDTARGET2) > 0) then
		return "{circle}";
	elseif (bit.band(flags, COMBATLOG_OBJECT_RAIDTARGET3) > 0) then
		return "{diamond}";
	elseif (bit.band(flags, COMBATLOG_OBJECT_RAIDTARGET4) > 0) then
		return "{triangle}";
	elseif (bit.band(flags, COMBATLOG_OBJECT_RAIDTARGET5) > 0) then
		return "{moon}";
	elseif (bit.band(flags, COMBATLOG_OBJECT_RAIDTARGET6) > 0) then
		return "{square}";
	elseif (bit.band(flags, COMBATLOG_OBJECT_RAIDTARGET7) > 0) then
		return "{x}";
	elseif (bit.band(flags, COMBATLOG_OBJECT_RAIDTARGET8) > 0) then
		return "{skull}";
	else
		return "";
	end
end

function isCC(spellName)
	local auraCC = {"Polymorph","Repentance","Freezing Trap","Hex","Hammer of Justice","Entangling Roots","Hibernate","Sap","Blind","Fear","Seduction"};
	for k,v in ipairs(auraCC) do
		if (spellName == v) then
			return true
		end
	end
	return false;
end

intFrame:SetScript("OnEvent", intEvent);